//Problem F of ACM ICPC, Tehran Region, November 2009
//Author: Saeedreza Seddigihin (http://ce.sharif.edu/~seddighin)
//From team: Sibilization
#include <iostream>
#include <cstdio>
#include <map>
#include <vector>
#include <complex>
#define double long double

using namespace std; 

typedef complex<double> Point;

const double EPS=1e-8,INF=1e10;

int n;
double d;
 
inline double dist(Point a,Point b,Point c){
  return(abs(((c-a)/(b-a)).imag())*abs(b-a));
}

int main(){
  cout<<fixed;
  cout.precision(2);
  while (cin>>n>>d){
    if (n == 0 && abs(d) < EPS) break;
    vector<Point> num(n+1);
    for (int i=1;i<=n;i++){
      double a,b;
      cin>>a>>b;
      num[i]=Point(a,b);
    }
    vector<vector<bool> > good(n+1,vector<bool>(n+1,false));
    for (int i=1;i<=n;i++)
      for (int j=i+1;j<=n;j++){
	bool find=false;
	for (int k=i+1;k<j;k++) 
	  if (dist(num[i],num[j],num[k]) > d+EPS)
	    find=true;
	if (!find)
	  good[i][j]=true;
      }
    vector<double> dyna(n+1,INF);
    dyna[1]=0;
    for (int i=1;i<=n;i++)
      for (int j=i+1;j<=n;j++)
	if (good[i][j])
	  dyna[j]=min(dyna[j],dyna[i]+abs(num[i]-num[j]));
    cout<<dyna[n]<<endl;
  }
}
