//Problem G of ACM ICPC, Tehran Region, November 2009
//Author: Saeedreza Seddigihin (http://ce.sharif.edu/~seddighin)
//From team: Sibilization
#include <iostream>
#include <cstdio>
#include <map>
#include <vector>
#include <complex>
#define double long double

using namespace std; 

typedef complex<double> Point;

const double EPS=1e-10,INF=1e10;

inline bool zero(double s){
  return(abs(s) < EPS);
}

template<typename T>
struct Equation{
  vector<T> answer,result;
  vector<vector<T> > num;
  int n;

  Equation(int s):n(s){
    num.resize(n+1);
    for (int i=1;i<=n;i++) num[i].resize(n+1);
    answer.resize(n+1);
    result.resize(n+1);
  }
  void solve(){
    vector<int> index;
    for (int i=1;i<=n;i++){
      int last=i;
      for (int j=i+1;j<=n;j++) if (!zero(num[j][i])) last=j;
      for (int j=1;j<=n;j++) swap(num[last][j],num[i][j]);
      swap(answer[last],answer[i]);
      if (!zero(num[i][i])){
	for (int j=1;j<=n;j++) 
	  if (j!=i){
	    T zarib=num[j][i]/num[i][i];
	    for (int k=1;k<=n;k++) 
	      num[j][k]-=zarib*num[i][k];
	    answer[j]-=zarib*answer[i];
	  }
      }
      for (int i=1;i<=n;i++) result[i]=answer[i]/num[i][i];
    }
  }
};

map<string,int> Map;

int find(string s){
  for (int i=0;i<=s.size();i++)
    if (Map.find(s.substr(i)) != Map.end())
      return(Map[s.substr(i)]);
  return(0);
}
 
int main(){
  string first,second;
  cout<<fixed;
  cout.precision(3);
  while (cin>>first>>second){
    if (first == "0" && second == "0")
      break;
    Map.clear();
    for (int i=0;i<=first.size();i++)
      Map[first.substr(0,i)]=0;
    for (int i=0;i<=second.size();i++)
      Map[second.substr(0,i)]=0;

    int count=1;
    for (map<string,int> :: iterator i=Map.begin();i!=Map.end();i++,count++)
      i->second=count;

    /*    
    for (map<string,int> :: iterator i=Map.begin();i!=Map.end();i++)
      cout<<i->first<<' '<<i->second<<endl;
    */

    int n=Map.size();
    Equation<double> mai(Map.size());
    for (map<string,int> :: iterator i=Map.begin();i!=Map.end();i++){
      // if ((i->first) == first && (i->first != second)) break;
      for (char j='0';j<='1';j++){
	mai.num[i->second][find(i->first+j)]-=0.5;
      }
    }


    for (int i=1;i<=n;i++) mai.num[Map[first]][i]=0;
    for (int i=1;i<=n;i++) mai.num[Map[second]][i]=0;

    for (int i=1;i<=n;i++) mai.num[i][i]+=1;
    mai.answer[Map[second]]=1;

    /*
    for (map<string,int> :: iterator i=Map.begin();i!=Map.end();i++)
      cout<<i->first<<' '<<i->second<<endl;
    */
    /*
    for (int i=1;i<=n;i++,cout<<endl){
      for (int j=1;j<=n;j++)
	cout<<mai.num[i][j]<<' ';
    }
    cout<<endl;
    */



    mai.solve();
    cout<<1-mai.result[1]<<endl;
  }
}
