//Problem I of ACM ICPC, Tehran Region, November 2009
//Author: Saeedreza Seddigihin (http://ce.sharif.edu/~seddighin)
//From team: Sibilization
#include <iostream>
#include <cstdio>
#include <map>
#include <vector>
#include <complex>
#define double long double

using namespace std; 

const int MAX_N=200+20;

struct Matching{
  int n,hus[MAX_N];
  bool mark[MAX_N];
  bool e[MAX_N][MAX_N];
  Matching(int s){
    for (int i=0;i<MAX_N;i++) fill(e[i],e[i]+MAX_N,false);
    n=s;
    fill(hus,hus+MAX_N,0);
  }
  inline bool find(int s){
    if (mark[s]) return(false);
    mark[s]=true;
    for (int i=1;i<=n;i++)
      if (e[s][i]){
	if (!hus[i] || (hus[i] && find(hus[i]))){
	  hus[i]=s;
	  return(true);
	}
      }
    return(false);
  }
  int MaxMatching(){
    int ans=0;
    for (int i=1;i<=n;i++){
      fill(mark+1,mark+n+1,false);
      ans+=find(i);
    }
    return(ans);
  }
};

int main(){
  int n,m;
  while (cin>>n>>m){
    vector<vector<bool> > e(n+1,vector<bool>(n+1));
    if (n ==0 && m == 0) break;
    for (int i=1;i<=n;i++){
      int temp;
      cin>>temp;
      for (int j=1;j<=temp;j++){
	int x;
	cin>>x;
	//	cout<<i<<' '<<x<<endl;
	e[i][x]=true;
      }
    }

    vector<int> num(m+1);
    for (int i=1;i<=m;i++) cin>>num[i];

    /*
    for (int i=1;i<=m;i++) cout<<num[i]<<' ';
    cout<<endl;
    */
    Matching mai(m);
    for (int i=1;i<=m;i++)
      for (int j=i+1;j<=m;j++){
	if (e[num[i]][num[j]]){
	  mai.e[i][j]=true;
	}
      }

    int first=m-mai.MaxMatching();
    int second=0;
    for (int i=1;i<=m;i++) 
      if (e[1][num[i]])
	second++;
    cout<<first<<' '<<second<<endl;
  }
}
