//Problem J of ACM ICPC, Tehran Region, November 2009
//Author: Aideen NasiriShargh (aideen.ir)
//From team: Sibilization
#include <cctype>
#include <iostream>
#include <string>
#include <cstring>
#include <set>
#include <algorithm>
#define FOR(i,x,n) for(__typeof(x) i = (x); i != (n); i++)
#define FR(i,n) FOR(i,0,n)
#define FRI(it,v) FOR(it,v.begin(),v.end())
#define SZ size()
#define CLR(a,v) memset(a,v,sizeof a)
#define MP make_pair
#define isin(a,v) ((a).find(v) != (a).end())
#define show(x) cerr<<#x<<"="<<x<<endl;
using namespace std;

const int MAX_N = 50*1000 + 13;

struct node {
  long long trap;
  int isfree;
  int child[2], ck;
  int parent;
} a[MAX_N];
int n;
int head;
int id[MAX_N], nid;
long long  d[MAX_N];

void DFS(int x) {
  if (x == -1) return;
  id[nid++] = x;
  FR(j,2) 
    DFS(a[x].child[j]);
}

int main() {
  while (cin >> n && n) {
    FR(i,n) {
      a[i].isfree = a[i].ck = 0;
      FR(j,2) a[i].child[j] = -1;
    }

    head = 0;
    FR(i,n) {
      cin >> a[i].parent >> a[i].isfree >> a[i].trap;
      a[i].parent--; // 0-based;
      int p = a[i].parent;
      if (p == -1) head = i;
      else a[p].child[a[p].ck++] = i;
    }

    FR(i,n)
      if (a[a[i].child[1]].isfree) 
	swap(a[i].child[0], a[i].child[1]);


    nid = 0;
    DFS(head);

    CLR(d, 0);
    for (int i=n-1; i>=0; i--) {
      int x = id[i];
      node &cur = a[x];

      if (cur.ck == 0)
	d[x] = cur.trap;
      else {
	int cx = d[cur.child[0]], cy = d[cur.child[1]];
	//cerr << x << " ! " << cx << " " << cy << endl;
	if (cx <= cy)
	  d[x] = 2*cx;
	else
	  d[x] = 2*cy + 1;
	d[x] += cur.trap;
      }
      //cerr << x << " : " << d[x] << endl;
    }

    int ans = d[head];
    cout << ans << endl;
  }
  return 0;
}
